#include <Wire.h>

String stringBIN, stringHEX;

void setup() 
{
  pinMode(13,OUTPUT);
  delay (500);
  Serial.begin(11520);
  Serial.println("Press s for searching i2c devices ... ");
}

void loop() 
{
  int incomingByte, i, n;

  if (Serial.available() > 0)
  {
    incomingByte = Serial.read();

    switch (incomingByte)
    {
      case 's':
        i2c_scanner();
      break;
      case '\'':
      case '\r':
      case '\n':
      break;
      default:
        Serial.println("Press C for searching I2C devices ... ");
        while (Serial.available() > 0) Serial.read();
      break;
    }
  }
}

void i2c_scanner(void)
{
  byte error, address;
  int nDevices;

  Serial.println(F(""));
  Serial.println(F("i2c_scanner"));
  Serial.println(F("Scanning..."));

  Wire.begin();

  nDevices = 0;
  for(address = 0; address <= 127; address++ ) 
  {
    Wire.beginTransmission(address);
    error = Wire.endTransmission();

    if (error == 0)
    {
      Serial.print(F("I2C device found at address 0x"));
      if (address<16) 
        Serial.print(F("0"));
      Serial.print(address,HEX);
      byte tmpDEC = (address);
      Serial.print(F(", DEC = "));
      Serial.print(tmpDEC);
      Serial.print(F(", HEX = B"));
      Serial.print(tmpDEC,BIN);
      Serial.println(F(" !"));

      nDevices++;
    }
    else if (error==4) 
    {
      Serial.print(F("Unknow error at address 0x"));
      if (address<16) 
        Serial.print(F("0"));
      Serial.println(address,HEX);
    }    
  }
  if (nDevices == 0)
    Serial.println(F("No I2C devices found."));
  else
    Serial.println(F("Done."));

  Serial.println(F("-----------"));
}

